import puppeteer from 'puppeteer';
import { optsWithDefaults } from './options.js';
export default class HeadlessEval {
    constructor(opts) {
        this.opts = optsWithDefaults(opts);
        this.browserPromise = puppeteer.launch();
    }
    async evalSnippet(url, snippet) {
        const browser = await this.browserPromise;
        const page = await browser.newPage();
        try {
            return await this.doEvalSnippetInPage(page, url, snippet);
        }
        finally {
            await page.close();
        }
    }
    async close() {
        const browser = await this.browserPromise;
        return browser.close();
    }
    async doEvalSnippetInPage(page, url, snippet) {
        await page.goto(url, {
            waitUntil: "networkidle2",
            timeout: 0,
        });
        const result = await page.evaluate(s => eval(s), snippet);
        const formattedResult = this.maybeSerialize(result);
        return formattedResult;
    }
    maybeSerialize(result) {
        if (this.opts.json)
            return JSON.stringify(result, undefined, '\t');
        if (Array.isArray(result))
            return result.join('\n');
        return result;
    }
}
//# sourceMappingURL=lib.js.map